/* GCC */

#define maxM 500    //    

#include <stdio.h>
#include <vector>

using namespace std;

vector<pair<int, int> > graph[maxM];
// graph[i][j].first   ,    i (  )
// graph[i][j].second    

int distances[maxM];
//      (-1,      )

bool visited[maxM];
//  ,         򳺿  ,
//    

int main()
{
    freopen("trains.in", "r", stdin);
    freopen("trains.out", "w", stdout);

    int n, m;

    //     :
    scanf("%d %d", &n, &m);
    for (int i = 0; i < n; i++)
    {
        int stations, current, previous, time;
        scanf("%d %d", &stations, &current);    // ʳ       
        for (int j = 0; j < stations - 1; j++)
        {
            previous = current;
            scanf("%d %d", &time, &current);    //       
            //    time   previous  current, , 
            //          ,   :
            graph[previous - 1].push_back(make_pair(current - 1, time));
            graph[current - 1].push_back(make_pair(previous - 1, time));
        }
    }

    //      0     :
    for (int i = 0; i < m; i++) //     
    {
        distances[i] = -1;
        visited[i] = false;
    }
    int addedVertex = 0;   //    0
    distances[addedVertex] = 0;
    while (addedVertex != -1)   //    ,   
    {
        visited[addedVertex] = true;    //    
        for (int i = 0; i < graph[addedVertex].size(); i++) //   ,    
        {
            int vertex = graph[addedVertex][i].first;   //   
            int weight = graph[addedVertex][i].second;  //   
            int distance = distances[addedVertex] + weight; // ,      vertex,    addedVertex
            if (distances[vertex] == -1 || distances[vertex] > distance)    //      ,  
                distances[vertex] = distance;
        }
        //     :
        addedVertex = -1;
        for (int i = 0; i < m; i++) //   
            if (! visited[i] && distances[i] != -1  //     ,   
                    && (addedVertex == -1 || distances[i] < distances[addedVertex])) //         
                addedVertex = i;
    }

    //  :     0   m-1
    printf("%d\n", distances[m - 1]);

    return 0;
}
